diff --git a/src/main/java/net/minecraft/core/block/JarBlock.java b/src/main/java/net/minecraft/core/block/JarBlock.java
index 82b78b608..4764f5a97 100644
--- a/src/main/java/net/minecraft/core/block/JarBlock.java
+++ b/src/main/java/net/minecraft/core/block/JarBlock.java
@@ -113,19 +113,6 @@ public class JarBlock extends EntityBlock {
         }
     }
 
-    @Override
-    public void onBlockRemoved(World world, int x, int y, int z, int data) {
-        FlowerJarBlockEntity tileEntity = (FlowerJarBlockEntity) world.getBlockEntity(x, y, z);
-        int flowerInPot = tileEntity.flowerInPot;
-        if (flowerInPot > 0 && hasTag(flowerInPot, BlockTags.PLANTABLE_IN_JAR)) {
-            tileEntity.flowerInPot = 0;
-            if (!world.isClientSide) {
-                world.dropItem(x, y, z, new ItemStack(flowerInPot, 1, 0));
-            }
-        }
-        super.onBlockRemoved(world, x, y, z, data);
-    }
-
     @Override
     public boolean isSolidRender()
     {
diff --git a/src/main/java/net/minecraft/core/block/JukeboxBlock.java b/src/main/java/net/minecraft/core/block/JukeboxBlock.java
index 6617e90d1..096fbdb3f 100644
--- a/src/main/java/net/minecraft/core/block/JukeboxBlock.java
+++ b/src/main/java/net/minecraft/core/block/JukeboxBlock.java
@@ -50,30 +50,8 @@ public class JukeboxBlock extends EntityBlock
         {
             return;
         }
-        JukeboxBlockEntity tileentityrecordplayer = (JukeboxBlockEntity)world.getBlockEntity(i, j, k);
-        int l = tileentityrecordplayer.record;
-        if (l != 0) {
-            world.playSoundEffect(1005, i, j, k, 0);
-            world.playRecord(null, null, i, j, k);
-            tileentityrecordplayer.record = 0;
-            tileentityrecordplayer.setChanged();
-            world.setBlockMetadataWithNotify(i, j, k, 0);
-            int i1 = l;
-            float f = 0.7F;
-            double d = (double) (world.rand.nextFloat() * f) + (double) (1.0F - f) * 0.5D;
-            double d1 = (double) (world.rand.nextFloat() * f) + (double) (1.0F - f) * 0.2D + 0.6D;
-            double d2 = (double) (world.rand.nextFloat() * f) + (double) (1.0F - f) * 0.5D;
-            ItemEntity entityitem = new ItemEntity(world, (double) i + d, (double) j + d1, (double) k + d2, new ItemStack(i1, 1, 0));
-            entityitem.pickupDelay = 10;
-            world.entityJoinedWorld(entityitem);
-        }
-    }
-
-    @Override
-    public void onBlockRemoved(World world, int x, int y, int z, int data)
-    {
-        ejectRecord(world, x, y, z);
-        super.onBlockRemoved(world, x, y, z, data);
+        BlockEntity blockEntity = world.getBlockEntity(i, j, k);
+        blockEntity.dropContents(world, i, j, k);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/LampBlock.java b/src/main/java/net/minecraft/core/block/LampBlock.java
index 9b5350105..be592ae3a 100644
--- a/src/main/java/net/minecraft/core/block/LampBlock.java
+++ b/src/main/java/net/minecraft/core/block/LampBlock.java
@@ -2,59 +2,48 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-import java.util.Random;
+public class LampBlock extends Block {
+    public boolean isActive;
 
-public class LampBlock extends Block
-{
     public LampBlock(String key, String namespaceId, int id, boolean isActivated) {
         super(key, namespaceId, id, Material.stone);
         isActive = isActivated;
-        setTicking(true);
     }
 
     @Override
-    public int tickDelay()
-    {
-        return 2;
-    }
-    
-    @Override
-	public void onBlockPlacedByWorld(World world, int x, int y, int z)
-    {
-        super.onBlockPlacedByWorld(world, x, y, z);
-        world.scheduleBlockUpdate(x, y, z, id, tickDelay());
-    }
+    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+        if (world.isClientSide) {
+            return;
+        }
 
-    @Override
-	public void updateTick(World world, int x, int y, int z, Random rand)
-    {
-        boolean isPoweredByBlock = world.isBlockGettingPowered(x, y, z) || world.isBlockIndirectlyGettingPowered(x, y, z);
-        if(isActive)
-        {
-            if(!isPoweredByBlock)
-                world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_IDLE.id, world.getBlockMetadata(x, y, z));
-        } else
-        if(isPoweredByBlock)
-        {
+        final boolean hasSignal = world.hasDirectSignal(x, y, z) || world.hasNeighborSignal(x, y, z);
+
+        if (hasSignal && !isActive) {
             world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_ACTIVE.id, world.getBlockMetadata(x, y, z));
+        } else if (!hasSignal && isActive) {
+            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_IDLE.id, world.getBlockMetadata(x, y, z));
         }
     }
 
     @Override
-	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
-    {
-        world.scheduleBlockUpdate(x, y, z, id, tickDelay());
+    public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
+        final boolean hasSignal = world.hasDirectSignal(x, y, z) || world.hasNeighborSignal(x, y, z);
+
+        if (hasSignal && !isActive) {
+            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_ACTIVE.id, world.getBlockMetadata(x, y, z));
+        } else if (!hasSignal && isActive) {
+            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_IDLE.id, world.getBlockMetadata(x, y, z));
+        }
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
-    {
-        return new ItemStack[] { new ItemStack(Blocks.LAMP_IDLE, 1, meta) };
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity) {
+        return new ItemStack[]{new ItemStack(Blocks.LAMP_IDLE, 1, meta)};
     }
-
-    public boolean isActive;
 }
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/core/block/LegacyChestBlock.java b/src/main/java/net/minecraft/core/block/LegacyChestBlock.java
index ee4ad0fe7..83b7b936d 100644
--- a/src/main/java/net/minecraft/core/block/LegacyChestBlock.java
+++ b/src/main/java/net/minecraft/core/block/LegacyChestBlock.java
@@ -43,7 +43,10 @@ public class LegacyChestBlock extends EntityBlock {
 	
 	@Override
 	public void onBlockRemoved(World world, int x, int y, int z, int data) {
-		ChestBlock.dropChestContent(world, x, y, z);
+		BlockEntity entity = world.getBlockEntity(x, y, z);
+		if (entity != null) {
+			entity.dropContents(world, x, y, z);
+		}
 		super.onBlockRemoved(world, x, y, z, data);
 	}
 	
diff --git a/src/main/java/net/minecraft/core/block/MotionSensorBlock.java b/src/main/java/net/minecraft/core/block/MotionSensorBlock.java
index 027013f01..8d8c53c39 100644
--- a/src/main/java/net/minecraft/core/block/MotionSensorBlock.java
+++ b/src/main/java/net/minecraft/core/block/MotionSensorBlock.java
@@ -99,7 +99,7 @@ public class MotionSensorBlock extends RotatableEntityBlock
         return getSignal(world, x, y, z, side);
     }
     @Override
-    public boolean getSignal(WorldSource blockAccess, int x, int y, int z, Side side)
+    public boolean getSignal(WorldSource worldSource, int x, int y, int z, Side side)
     {
         return isActive;
     }
diff --git a/src/main/java/net/minecraft/core/block/NoteBlock.java b/src/main/java/net/minecraft/core/block/NoteBlock.java
index 3ae00756d..e82d6bd7f 100644
--- a/src/main/java/net/minecraft/core/block/NoteBlock.java
+++ b/src/main/java/net/minecraft/core/block/NoteBlock.java
@@ -21,7 +21,7 @@ public class NoteBlock extends EntityBlock
     {
         if(blockId > 0 && Block.blocksList[blockId].isSignalSource())
         {
-            boolean flag = world.isBlockGettingPowered(x, y, z);
+            boolean flag = world.hasDirectSignal(x, y, z);
             NoteBlockEntity tileentitynote = (NoteBlockEntity)world.getBlockEntity(x, y, z);
             if(tileentitynote.previousRedstoneState != flag)
             {
diff --git a/src/main/java/net/minecraft/core/block/PaintedTrapDoorBlock.java b/src/main/java/net/minecraft/core/block/PaintedTrapDoorBlock.java
index c469ff609..8df5e8b66 100644
--- a/src/main/java/net/minecraft/core/block/PaintedTrapDoorBlock.java
+++ b/src/main/java/net/minecraft/core/block/PaintedTrapDoorBlock.java
@@ -10,7 +10,7 @@ import net.minecraft.core.world.World;
 
 public class PaintedTrapDoorBlock extends TrapDoorBlock {
     public PaintedTrapDoorBlock(String key, String namespaceId, int id, Material material) {
-        super(key, namespaceId, id, material, false);
+        super(key, namespaceId, id, material);
     }
     
     @Override
diff --git a/src/main/java/net/minecraft/core/block/PortalBlock.java b/src/main/java/net/minecraft/core/block/PortalBlock.java
index 85de42374..84bcb5825 100644
--- a/src/main/java/net/minecraft/core/block/PortalBlock.java
+++ b/src/main/java/net/minecraft/core/block/PortalBlock.java
@@ -265,7 +265,7 @@ public class PortalBlock extends TransparentBlock
         y = bounds[2];
         z = bounds[3];
 
-        world.editingBlocks = true;
+        world.noNeighborUpdate = true;
         for(int ra = 1; ra < bounds[4]; ra++)
         {
             for(int ry = 1; ry < bounds[5]; ry++)
@@ -279,7 +279,7 @@ public class PortalBlock extends TransparentBlock
         
         world.markBlocksDirty(x + (bounds[0] == 0 ? 1 : 0), y + 1, z + (bounds[0] == 1 ? 1 : 0), x + (bounds[0] == 0 ? bounds[4] : 0), y + bounds[5], z + (bounds[0] == 1 ? bounds[4] : 0));
 
-        world.editingBlocks = false;
+        world.noNeighborUpdate = false;
         return true;
     }
 
diff --git a/src/main/java/net/minecraft/core/block/PressurePlateBlock.java b/src/main/java/net/minecraft/core/block/PressurePlateBlock.java
index 8331bf503..4b790392b 100644
--- a/src/main/java/net/minecraft/core/block/PressurePlateBlock.java
+++ b/src/main/java/net/minecraft/core/block/PressurePlateBlock.java
@@ -162,10 +162,10 @@ public class PressurePlateBlock extends Block
     }
 
     @Override
-    public boolean getSignal(WorldSource blockAccess, int x, int y, int z, Side side)
+    public boolean getSignal(WorldSource worldSource, int x, int y, int z, Side side)
     {
 
-        return isPressed(blockAccess.getBlockMetadata(x, y, z));
+        return isPressed(worldSource.getBlockMetadata(x, y, z));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/RailBlock.java b/src/main/java/net/minecraft/core/block/RailBlock.java
index 74b5d5e29..d0749b316 100644
--- a/src/main/java/net/minecraft/core/block/RailBlock.java
+++ b/src/main/java/net/minecraft/core/block/RailBlock.java
@@ -103,8 +103,8 @@ public class RailBlock extends Block {
 
         if(this == Blocks.RAIL_POWERED) {
             boolean gettingPower =
-                    world.isBlockIndirectlyGettingPowered(x, y, z) ||
-                    world.isBlockIndirectlyGettingPowered(x, y + 1, z) ||
+                    world.hasNeighborSignal(x, y, z) ||
+                    world.hasNeighborSignal(x, y + 1, z) ||
                     isConnectedPoweredRail1(world, x, y, z, true, 0) ||
                     isConnectedPoweredRail1(world, x, y, z, false, 0);
 
@@ -150,7 +150,7 @@ public class RailBlock extends Block {
 
     private void performRailTurn(World world, int x, int y, int z, boolean forceUpdate) {
         if (!world.isClientSide) {
-            new Rail(world, x, y, z).railTurn(world.isBlockIndirectlyGettingPowered(x, y, z), forceUpdate);
+            new Rail(world, x, y, z).railTurn(world.hasNeighborSignal(x, y, z), forceUpdate);
         }
     }
 
@@ -217,7 +217,7 @@ public class RailBlock extends Block {
 
             if(isPoweredFlagSet) {
                 // If rail powered return true
-                if(world.isBlockIndirectlyGettingPowered(x, y, z) || world.isBlockIndirectlyGettingPowered(x, y + 1, z)) {
+                if(world.hasNeighborSignal(x, y, z) || world.hasNeighborSignal(x, y + 1, z)) {
                     return true;
                 } else { // else check 1 block further down if powered
                     return isConnectedPoweredRail1(world, x, y, z, forward, distance + 1);
diff --git a/src/main/java/net/minecraft/core/block/RedstoneBlock.java b/src/main/java/net/minecraft/core/block/RedstoneBlock.java
index 89a15b9f1..126ffeb1c 100644
--- a/src/main/java/net/minecraft/core/block/RedstoneBlock.java
+++ b/src/main/java/net/minecraft/core/block/RedstoneBlock.java
@@ -23,7 +23,7 @@ public class RedstoneBlock extends Block
     }
 	
     @Override
-    public boolean getSignal(WorldSource blockAccess, int x, int y, int z, Side side)
+    public boolean getSignal(WorldSource worldSource, int x, int y, int z, Side side)
     {
     	return true;
     }
@@ -31,7 +31,7 @@ public class RedstoneBlock extends Block
     @Override
     public boolean getDirectSignal(World world, int x, int y, int z, Side side)
     {
-        return getSignal(world, x, y, z, side);
+        return false;
     }
     
     @Override
diff --git a/src/main/java/net/minecraft/core/block/RedstonePumpkinBlock.java b/src/main/java/net/minecraft/core/block/RedstonePumpkinBlock.java
index 6d64c8580..35c3d21ca 100644
--- a/src/main/java/net/minecraft/core/block/RedstonePumpkinBlock.java
+++ b/src/main/java/net/minecraft/core/block/RedstonePumpkinBlock.java
@@ -29,15 +29,15 @@ public class RedstonePumpkinBlock extends RotatableBlock {
 
     @Override
     public boolean getDirectSignal(World world, int x, int y, int z, Side side) {
-        return getSignal(world, x, y, z, side);
+        return getSignal(world, x, y, z, side.getOpposite());
     }
 
     @Override
-    public boolean getSignal(WorldSource blockAccess, int x, int y, int z, Side side) {
+    public boolean getSignal(WorldSource worldSource, int x, int y, int z, Side side) {
         if (!side.isHorizontal()) {
             return false;
         }
-        Side mySide = Side.getSideById(blockAccess.getBlockMetadata(x, y, z));
+        Side mySide = Side.getSideById(worldSource.getBlockMetadata(x, y, z));
         return mySide == side.getOpposite();
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/RedstoneTorchBlock.java b/src/main/java/net/minecraft/core/block/RedstoneTorchBlock.java
index a721200fa..a683353bc 100644
--- a/src/main/java/net/minecraft/core/block/RedstoneTorchBlock.java
+++ b/src/main/java/net/minecraft/core/block/RedstoneTorchBlock.java
@@ -4,41 +4,33 @@ import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-import java.util.ArrayList;
-import java.util.List;
 import java.util.Random;
 
-// Referenced classes of package net.minecraft.src:
-//            TorchBlock, Block, RedstoneUpdateInfo, World,
-//            IBlockAccess
+public class RedstoneTorchBlock extends TorchBlock {
+    private final boolean torchActive;
 
-public class RedstoneTorchBlock extends TorchBlock
-{
-    protected RedstoneTorchBlock(String key, String namespaceId, int id, boolean isActive) {
+    public RedstoneTorchBlock(String key, String namespaceId, int id, boolean isActive) {
         super(key, namespaceId, id);
         torchActive = isActive;
         setTicking(true);
     }
 
     @Override
-    public int tickDelay()
-    {
+    public int tickDelay() {
         return 2;
     }
 
     @Override
-	public void onBlockPlacedByWorld(World world, int x, int y, int z)
-    {
-        if(world.getBlockMetadata(x, y, z) == 0) {
+    public void onBlockPlacedByWorld(World world, int x, int y, int z) {
+        if (world.getBlockMetadata(x, y, z) == 0) {
             super.onBlockPlacedByWorld(world, x, y, z);
         }
-        if(torchActive) {
+        if (torchActive) {
             world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
             world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
             world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
@@ -50,7 +42,7 @@ public class RedstoneTorchBlock extends TorchBlock
 
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data) {
-        if(torchActive) {
+        if (torchActive) {
             world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
             world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
             world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
@@ -61,69 +53,64 @@ public class RedstoneTorchBlock extends TorchBlock
     }
 
     @Override
-    public boolean getSignal(WorldSource blockAccess, int x, int y, int z, Side side) {
-        if(!torchActive) {
+    public boolean getSignal(WorldSource worldSource, int x, int y, int z, Side side) {
+        if (!torchActive) {
             return false;
         }
-        int meta = blockAccess.getBlockMetadata(x, y, z);
-        if(meta == 5 && side == Side.TOP) {
+        int meta = worldSource.getBlockMetadata(x, y, z);
+        if (meta == 5 && side == Side.TOP) {
             return false;
         }
-        if(meta == 3 && side == Side.SOUTH) {
+        if (meta == 3 && side == Side.SOUTH) {
             return false;
         }
-        if(meta == 4 && side == Side.NORTH) {
+        if (meta == 4 && side == Side.NORTH) {
             return false;
         }
-        if(meta == 1 && side == Side.EAST) {
+        if (meta == 1 && side == Side.EAST) {
             return false;
         }
         return meta != 2 || side != Side.WEST;
     }
 
-    private boolean isPoweredByBlock(World world, int x, int y, int z) {
+    private boolean hasNeighborSignal(World world, int x, int y, int z) {
         int meta = world.getBlockMetadata(x, y, z);
-        if(meta == 5 && world.isBlockIndirectlyProvidingPowerTo(x, y - 1, z, Side.BOTTOM)) {
+        if (meta == 5 && world.getSignal(x, y - 1, z, Side.BOTTOM)) {
             return true;
         }
-        if(meta == 3 && world.isBlockIndirectlyProvidingPowerTo(x, y, z - 1, Side.NORTH)) {
+        if (meta == 3 && world.getSignal(x, y, z - 1, Side.NORTH)) {
             return true;
         }
-        if(meta == 4 && world.isBlockIndirectlyProvidingPowerTo(x, y, z + 1, Side.SOUTH)) {
+        if (meta == 4 && world.getSignal(x, y, z + 1, Side.SOUTH)) {
             return true;
         }
-        if(meta == 1 && world.isBlockIndirectlyProvidingPowerTo(x - 1, y, z, Side.WEST)) {
+        if (meta == 1 && world.getSignal(x - 1, y, z, Side.WEST)) {
             return true;
         }
-        return meta == 2 && world.isBlockIndirectlyProvidingPowerTo(x + 1, y, z, Side.EAST);
+        return meta == 2 && world.getSignal(x + 1, y, z, Side.EAST);
     }
 
     @Override
-	public void updateTick(World world, int x, int y, int z, Random rand)
-    {
-        boolean isPowered = isPoweredByBlock(world, x, y, z);
-        if(torchActive)
-        {
-            if(isPowered)
-            {
+    public void updateTick(World world, int x, int y, int z, Random rand) {
+        boolean isPowered = hasNeighborSignal(world, x, y, z);
+        if (torchActive) {
+            if (isPowered) {
                 world.setBlockAndMetadataWithNotify(x, y, z, Blocks.TORCH_REDSTONE_IDLE.id, world.getBlockMetadata(x, y, z));
             }
-        } else if(!isPowered) {
+        } else if (!isPowered) {
             world.setBlockAndMetadataWithNotify(x, y, z, Blocks.TORCH_REDSTONE_ACTIVE.id, world.getBlockMetadata(x, y, z));
         }
     }
 
     @Override
-	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
-    {
+    public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
         super.onNeighborBlockChange(world, x, y, z, blockId);
         world.scheduleBlockUpdate(x, y, z, id, tickDelay());
     }
 
     @Override
-    public boolean getDirectSignal(World world, int x, int y, int z, Side side)
-    {
-        if(side == Side.BOTTOM) {
+    public boolean getDirectSignal(World world, int x, int y, int z, Side side) {
+        if (side == Side.BOTTOM) {
             return getSignal(world, x, y, z, side);
         } else {
             return false;
@@ -132,51 +119,47 @@ public class RedstoneTorchBlock extends TorchBlock
 
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity) {
-        return new ItemStack[] { new ItemStack(Blocks.TORCH_REDSTONE_ACTIVE) };
+        return new ItemStack[]{new ItemStack(Blocks.TORCH_REDSTONE_ACTIVE)};
     }
 
     @Override
-    public boolean isSignalSource()
-    {
+    public boolean isSignalSource() {
         return true;
     }
 
     @Override
-	public void animationTick(World world, int x, int y, int z, Random rand) {
-		if (!torchActive) {
-			return;
-		}
-		
-		int meta = world.getBlockMetadata(x, y, z);
-		double px = (x + 0.5D) + (rand.nextFloat() - 0.5D) * 0.2D;
-		double py = (y + 0.7D) + (rand.nextFloat() - 0.5D) * 0.2D;
-		double pz = (z + 0.5D) + (rand.nextFloat() - 0.5D) * 0.2D;
-		
-		double verticalOffset = 0.22D;
-		double horizontalOffset = 0.27D;
+    public void animationTick(World world, int x, int y, int z, Random rand) {
+        if (!torchActive) {
+            return;
+        }
 
-        final int redstoneBrightness = 10;
-		Color color = Colors.allRedstoneColors[redstoneBrightness];
-		if(color == null) {
-			return;
-		}
-		float red = color.getRed() / 255.0f;
-		float green = color.getGreen() / 255.0f;
-		float blue = color.getBlue() / 255.0f;
-		
-		if (meta == 1) {
-			world.spawnParticle("reddust", px - horizontalOffset, py + verticalOffset, pz, red, green, blue, redstoneBrightness);
-		} else if (meta == 2) {
-			world.spawnParticle("reddust", px + horizontalOffset, py + verticalOffset, pz, red, green, blue, redstoneBrightness);
-		} else if (meta == 3) {
-			world.spawnParticle("reddust", px, py + verticalOffset, pz - horizontalOffset, red, green, blue, redstoneBrightness);
-		} else if (meta == 4) {
-			world.spawnParticle("reddust", px, py + verticalOffset, pz + horizontalOffset, red, green, blue, redstoneBrightness);
-		} else {
-			world.spawnParticle("reddust", px, py, pz, red, green, blue, redstoneBrightness);
-		}
-	}
+        int meta = world.getBlockMetadata(x, y, z);
+        double px = (x + 0.5D) + (rand.nextFloat() - 0.5D) * 0.2D;
+        double py = (y + 0.7D) + (rand.nextFloat() - 0.5D) * 0.2D;
+        double pz = (z + 0.5D) + (rand.nextFloat() - 0.5D) * 0.2D;
 
-    private final boolean torchActive;
+        double verticalOffset = 0.22D;
+        double horizontalOffset = 0.27D;
 
+        final int redstoneBrightness = 10;
+        Color color = Colors.allRedstoneColors[redstoneBrightness];
+        if (color == null) {
+            return;
+        }
+        float red = color.getRed() / 255.0f;
+        float green = color.getGreen() / 255.0f;
+        float blue = color.getBlue() / 255.0f;
+
+        if (meta == 1) {
+            world.spawnParticle("reddust", px - horizontalOffset, py + verticalOffset, pz, red, green, blue, redstoneBrightness);
+        } else if (meta == 2) {
+            world.spawnParticle("reddust", px + horizontalOffset, py + verticalOffset, pz, red, green, blue, redstoneBrightness);
+        } else if (meta == 3) {
+            world.spawnParticle("reddust", px, py + verticalOffset, pz - horizontalOffset, red, green, blue, redstoneBrightness);
+        } else if (meta == 4) {
+            world.spawnParticle("reddust", px, py + verticalOffset, pz + horizontalOffset, red, green, blue, redstoneBrightness);
+        } else {
+            world.spawnParticle("reddust", px, py, pz, red, green, blue, redstoneBrightness);
+        }
+    }
 }
